/*****************************************************************************
 
  Zope Public License (ZPL) Version 0.9.4
  ---------------------------------------
  
  Copyright (c) Digital Creations.  All rights reserved.
  
  Redistribution and use in source and binary forms, with or
  without modification, are permitted provided that the following
  conditions are met:
  
  1. Redistributions in source code must retain the above
     copyright notice, this list of conditions, and the following
     disclaimer.
  
  2. Redistributions in binary form must reproduce the above
     copyright notice, this list of conditions, and the following
     disclaimer in the documentation and/or other materials
     provided with the distribution.
  
  3. Any use, including use of the Zope software to operate a
     website, must either comply with the terms described below
     under "Attribution" or alternatively secure a separate
     license from Digital Creations.
  
  4. All advertising materials, documentation, or technical papers
     mentioning features derived from or use of this software must
     display the following acknowledgement:
  
       "This product includes software developed by Digital
       Creations for use in the Z Object Publishing Environment
       (http://www.zope.org/)."
  
  5. Names associated with Zope or Digital Creations must not be
     used to endorse or promote products derived from this
     software without prior written permission from Digital
     Creations.
  
  6. Redistributions of any form whatsoever must retain the
     following acknowledgment:
  
       "This product includes software developed by Digital
       Creations for use in the Z Object Publishing Environment
       (http://www.zope.org/)."
  
  7. Modifications are encouraged but must be packaged separately
     as patches to official Zope releases.  Distributions that do
     not clearly separate the patches from the original work must
     be clearly labeled as unofficial distributions.
  
  Disclaimer
  
    THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND
    ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
    FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT
    SHALL DIGITAL CREATIONS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
    DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
    IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
    THE POSSIBILITY OF SUCH DAMAGE.
  
  Attribution
  
    Individuals or organizations using this software as a web site
    must provide attribution by placing the accompanying "button"
    and a link to the accompanying "credits page" on the website's
    main entry point.  In cases where this placement of
    attribution is not feasible, a separate arrangment must be
    concluded with Digital Creations.  Those using the software
    for purposes other than web sites must provide a corresponding
    attribution in locations that include a copyright using a
    manner best suited to the application environment.
  
  This software consists of contributions made by Digital
  Creations and many individuals on behalf of Digital Creations.
  Specific attributions are listed in the accompanying credits
  file.
  
 ****************************************************************************/


%{
static char *
PySequence_CharArray(PyObject *s, int *d)
{
  if((*d=PyString_Size(s)) < 0) return NULL;
  return PyString_AsString(s);
}  

static void ___FreeConnect(void *p)
{
  if(p && (SQLHDBC*)p != SQL_NULL_HDBC)
    {
      UNLESS(SQLFreeConnect(*(SQLHDBC*)p) == SQL_SUCCESS)
	PyErr_SetString(PyExc_SQLError,
			"error calling SQLFreeConnect in destructor");
      free(p);
    }
}

static void ___FreeStmt(void *p)
{
  if(p && (SQLHSTMT*)p != SQL_NULL_HSTMT)
    {
      UNLESS(SQLFreeStmt(*(SQLHSTMT*)p, SQL_DROP) == SQL_SUCCESS)
	PyErr_SetString(PyExc_SQLError,
			"error calling SQLFreeStmt in destructor");
      free(p);
    }
}

%}

%include typemaps.i

%typemap(python, ignore) SQLHDBC * {
  $target = ($type)malloc(sizeof(SQLHDBC));
}

%typemap(python,argout) SQLHDBC * {
  $target = t_output_helper($target,PyCObject_FromVoidPtr((void*)$source,
							  ___FreeConnect));
}

%typemap(python, ignore) SQLHSTMT * {
  $target = ($type)malloc(sizeof(SQLHSTMT));
}

%typemap(python,argout) SQLHSTMT * {
  $target = t_output_helper($target, PyCObject_FromVoidPtr((void*)$source,
							   ___FreeStmt));
}

%typemap(python,ignore) SQLHENV { $target=SQLEnv; }

%typemap(python,in) SQLHDBC(SQLHDBC handle) {
  if($source==Py_None) $target=NULL;
  else if($source->ob_type == &ConnectionType)
    {
      $target = ((Connection*)$source)->connection;
    }
  else
    {
      UNLESS(PyCObject_Check($source))
	{
	  PyErr_SetString(PyExc_TypeError,
			  "Expected CObject");
	  return NULL;
	}
      $target=*($type *)PyCObject_AsVoidPtr($source);
    }
  handle=$target;
}

%typemap(python,in) SQLHSTMT(SQLHSTMT handle) {
  if($source==Py_None) $target=NULL;
  else if($source->ob_type == &StatementType)
    {
      $target = ((Statement*)$source)->stmt;
    }
  else
    {
      UNLESS(PyCObject_Check($source))
	{
	  PyErr_SetString(PyExc_TypeError,
			  "Expected CObject");
	  return NULL;
	}
      $target=*($type *)PyCObject_AsVoidPtr($source);
    }
  handle=$target;
}

%typemap(python, ignore) SQLCHAR *OUT1 (int dim1, SQLCHAR buf1[256]), 
                         SQLPOINTER OUT1(int dim1, SQLCHAR buf1[256])
{
  dim1=255;
  $target=buf1;
}

%typemap(python, argout) SQLCHAR *OUT1, SQLPOINTER OUT1
{
  $target = t_output_helper($target, PyString_FromStringAndSize(
     buf1, odim1)); 
}

%typemap(python, ignore) SQLSMALLINT *ODIM1(SQLSMALLINT odim1) {
  $target=&odim1; odim1=0; }

%typemap(python, ignore) SQLCHAR *OUT2(SQLSMALLINT dim2, SQLCHAR buf2[256]), 
                         SQLPOINTER OUT2(SQLSMALLINT dim2, SQLCHAR buf2[256])
{
  dim2=255;
  $target=buf2;
}

%typemap(python, argout) SQLCHAR *OUT2, SQLPOINTER OUT2
{
  $target = t_output_helper($target, PyString_FromStringAndSize(
     buf2, odim2)); 
}

%typemap(python, ignore) SQLSMALLINT *ODIM2(SQLSMALLINT odim2) {
  $target=&odim2; odim2=0; }

%typemap(python, in) SQLCHAR *IN1(int dim1)
  { 
    if($source==Py_None) { $target=NULL; dim1=0; }
    else UNLESS($target=PySequence_CharArray($source, &dim1)) return NULL; }

%typemap(python, ignore) SQLSMALLINT DIM1, SQLINTEGER DIM1 {}
%typemap(python, check) SQLSMALLINT DIM1, SQLINTEGER DIM1 { $target=dim1;}

%typemap(python, in) SQLCHAR *IN2(int dim2)
  { 
    if($source==Py_None) { $target=NULL; dim2=0; }
    else UNLESS($target=PySequence_CharArray($source, &dim2)) return NULL; }

%typemap(python, ignore) SQLSMALLINT DIM2 {}
%typemap(python, check) SQLSMALLINT DIM2 { $target=dim2;}

%typemap(python, in) SQLCHAR *IN3(int dim3)
  { 
    if($source==Py_None) { $target=NULL; dim3=0; }
    else UNLESS($target=PySequence_CharArray($source, &dim3)) return NULL; }

%typemap(python, ignore) SQLSMALLINT DIM3 {}
%typemap(python, check) SQLSMALLINT DIM3 { $target=dim3;}

%typemap(python, in) SQLCHAR *IN4(int dim4)
  { 
    if($source==Py_None) { $target=NULL; dim4=0; }
    else UNLESS($target=PySequence_CharArray($source, &dim4)) return NULL; }

%typemap(python, ignore) SQLSMALLINT DIM4 {}
%typemap(python, check) SQLSMALLINT DIM4 { $target=dim4;}

%typemap(python, ignore) SQLCHAR *szSqlState(char buf[6]){$target=buf;}
%typemap(python, argout) SQLCHAR *szSqlState {
  $target = t_output_helper($target, PyString_FromStringAndSize(buf, 5)); 
}
